// WatchMeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WatchMe.h"
#include "WatchMeDlg.h"
#include "process.h"
#include <time.h>
#include <sys/types.h>
#include <sys/timeb.h>

int iInactive = 0;
int iNowShow = 0;
char *pInactive = (char *)malloc(10);
int iTimer = 1000;										// refresh rate
char * pGData = (char *)malloc(1000);
char * pGData2= (char *)malloc(500);
CProgressCtrl *pP;

// Generate thread
UINT GSmain ( LPVOID pParam );

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWatchMeDlg dialog

CWatchMeDlg::CWatchMeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWatchMeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWatchMeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
//return;
	m_pEditBkBrush = new CBrush(RGB(0, 0, 0));
}

void CWatchMeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWatchMeDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWatchMeDlg, CDialog)
	//{{AFX_MSG_MAP(CWatchMeDlg)
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnDisplayButton)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_BUTTON7, OnDeleteButton)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_BUTTON8, OnGenerate)
	ON_EN_CHANGE(IDC_EDIT12, OnChangeMessageNumber)
	ON_EN_CHANGE(IDC_EDIT18, OnChangeRefresh)
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWatchMeDlg message handlers

BOOL CWatchMeDlg::OnInitDialog()
{
	FILE *fIni;
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// Connect to Queue manager

	qmgr.setName( pQmgr );
  if ( ! qmgr.connect( ) ) {
		// stop if it failed 
		MessageBox("Problem with MQ connect.  Minimum startup: watchq qmgr queue [queue2 ...queue5]", NULL, MB_OK);
		exit(0);

  } //if
	// Set Window Caption
  SetWindowText(qmgr.name());	

  // set up queues
	int i = 0;
	size_t iMaxName = 0;
	while (pQueue[i]) {
		queue[i].setName( pQueue[i] );
		if (strlen(pQueue[i]) > iMaxName) iMaxName = strlen(pQueue[i]);
		queue[i].setConnectionReference( this->qmgr );
		i++;
		if (i == 5) break;
	}
	
	// Set default queue status
	for (i=0;i<5;i++) iOK[i] = 1;

	// Set queue name
	SetDlgItemText(IDC_EDIT2, pQueue[0]);
	if (pQueue[1]) {
		SetDlgItemText(IDC_EDIT4, pQueue[1]);
		((CButton *)GetDlgItem(IDC_RADIO2))->EnableWindow(TRUE);
	}
	if (pQueue[2]) {
		SetDlgItemText(IDC_EDIT6, pQueue[2]);
		((CButton *)GetDlgItem(IDC_RADIO3))->EnableWindow(TRUE);
	}
	if (pQueue[3]) {
		SetDlgItemText(IDC_EDIT8, pQueue[3]);
		((CButton *)GetDlgItem(IDC_RADIO4))->EnableWindow(TRUE);
	}
	if (pQueue[4]) {
		SetDlgItemText(IDC_EDIT10, pQueue[4]);
		((CButton *)GetDlgItem(IDC_RADIO5))->EnableWindow(TRUE);
	}

	// Set initial size of window
	if (pQueue[4]) {
		SetWindowPos(this, 100,100,(int)(130+iMaxName*5.6),150,SWP_NOZORDER );
	} else {
		if (pQueue[3]) {
			SetWindowPos(this, 100,100,(int)(130+iMaxName*5.6),125,SWP_NOZORDER );
		} else {
			if (pQueue[2]) {
				SetWindowPos(this, 100,100,(int)(130+iMaxName*5.6),100,SWP_NOZORDER );
			} else {
			if (pQueue[1]) {
				SetWindowPos(this, 100,100,(int)(130+iMaxName*5.6),75,SWP_NOZORDER );
			} else SetWindowPos(this, 100,100,(int)(130+iMaxName*5.6),50,SWP_NOZORDER );
		}
	}}

	// Keep window on top
	SetWindowPos( &wndTopMost , 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW );
	SetTimer(0, iTimer, NULL);
	
	// Set default buttons checked
	((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(1);	   // keep on top
	((CButton *)GetDlgItem(IDC_RADIO1))->SetCheck(1);    // First queue
	((CButton *)GetDlgItem(IDC_RADIO20))->SetCheck(1);   // Random generate button
	((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(1);	   // Confirm delete

  SetDlgItemInt(IDC_EDIT12, 1, FALSE);								// message to show
	SetDlgItemInt(IDC_EDIT11, 80, FALSE);								// queue full warning at
	SetDlgItemInt(IDC_EDIT18, iTimer/1000, FALSE);						// refresh rate
	SetDlgItemInt(IDC_EDIT19, 1024, FALSE);							// Bytes in random message
	SetDlgItemInt(IDC_EDIT16, 1, FALSE);								// Number of messages to send
	SetDlgItemInt(IDC_EDIT17, 0, FALSE);								// Sleep between messages

	// Look for startup file watchq.ini, if there, fill in default values
  fIni = fopen("watchq.ini", "r");
	if (fIni) {
		char * pIni = (char *)malloc(500);
		char * pS1 = (char *)malloc(500);
		int iIni = 0;

		fscanf(fIni, "%d", &iIni);
    if (iIni) ((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(1);   // stay on top
		fscanf(fIni, "%d", &iIni);
		SetDlgItemInt(IDC_EDIT11, iIni, FALSE);							// queue full warning at
		fscanf(fIni, "%d", &iTimer);  
		SetDlgItemInt(IDC_EDIT18, iTimer, FALSE);	iTimer *= 1000;	// refresh rate
		fscanf(fIni, "%d", &iIni);
    if (iIni) ((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(1);
		else ((CButton *)GetDlgItem(IDC_CHECK3))->SetCheck(0);   // confirm del
		fscanf(fIni, "%d", &iIni);
		SetDlgItemInt(IDC_EDIT16, iIni, FALSE);							// number of msgs to send
		fscanf(fIni, "%d", &iIni);
		SetDlgItemInt(IDC_EDIT17, iIni, FALSE);							// sleep between msgs
		fscanf(fIni, "%d", &iIni);
		if (iIni) ((CButton *)GetDlgItem(IDC_CHECK5))->SetCheck(1);	// random sleep?
		fscanf(fIni, "%s", pS1);														// read b,q,f
		switch (*pS1) {
		case 'q' :
			((CButton *)GetDlgItem(IDC_RADIO21))->SetCheck(1);  // Random generate button
			((CButton *)GetDlgItem(IDC_RADIO20))->SetCheck(0);  // Random generate button
			break;
		case 'f' :
			((CButton *)GetDlgItem(IDC_RADIO22))->SetCheck(1);  // Random generate button
			((CButton *)GetDlgItem(IDC_RADIO20))->SetCheck(0);  // Random generate button
			break;
		default :
			((CButton *)GetDlgItem(IDC_RADIO20))->SetCheck(1);  // Random generate button
		}
		fscanf(fIni, "%d", &iIni);
		SetDlgItemInt(IDC_EDIT19, iIni, FALSE);							// bytes in random msg
		fscanf(fIni, "%s", pS1);
		SetDlgItemText(IDC_EDIT20, pS1);										// input queue
		fscanf(fIni, "%s", pS1);
		SetDlgItemText(IDC_EDIT22, pS1);										// input file
		fscanf(fIni, "%d", &iIni);
    if (iIni) ((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(1);   // Generate CorrelID

		fclose(fIni);
		free(pIni);
		free(pS1);
	}

	// Spin button Controls
	((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetBuddy(GetDlgItem(IDC_EDIT12));
	
  iNowShow = 1;
	pP = (CProgressCtrl *)GetDlgItem(IDC_PROGRESS1);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWatchMeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CWatchMeDlg::OnTimer(UINT nIDEvent) 
{
	double dWarning = GetDlgItemInt(IDC_EDIT11, NULL, TRUE);
	if (dWarning > 100) dWarning = 100;
	SetDlgItemInt(IDC_EDIT11, (int)dWarning, TRUE);
	dWarning /= 100;

	SetDlgItemInt(IDC_EDIT1, queue[0].currentDepth(), FALSE);
	if (queue[0].currentDepth() > (dWarning * queue[0].maximumDepth())) iOK[0] = 0; else iOK[0] = 1;
	if ((queue[0].reasonCode() == MQRC_CONNECTION_BROKEN) | 
		  (queue[0].reasonCode() == MQRC_NO_CONNECTION_REFERENCE) |
			(queue[0].reasonCode() == MQRC_Q_MGR_NOT_AVAILABLE)) {
		qmgr.disconnect();
		// try to reconnect
		if ( !qmgr.connect( ) ) {
			iInactive++;
			strcpy(pInactive, "R");
			strcat(pInactive, itoa(iInactive, pInactive+5, 10));
			SetDlgItemText(IDC_EDIT1, pInactive);
			SetTimer(0, iInactive * 1000, NULL);
		} else {
			iInactive = 0;
			SetTimer(0, iTimer, NULL);
		}
	} else {
		if (iInactive) {
			iInactive = 0;
			SetTimer(0, iTimer, NULL);
		}
		if (pQueue[1]) {
			SetDlgItemInt(IDC_EDIT3, queue[1].currentDepth(), FALSE);
			if (queue[1].currentDepth() > (dWarning * queue[1].maximumDepth())) iOK[1] = 0; else iOK[1] = 1;
		}
		if (pQueue[2]) {
			SetDlgItemInt(IDC_EDIT5, queue[2].currentDepth(), FALSE);
			if (queue[2].currentDepth() > (dWarning * queue[2].maximumDepth())) iOK[2] = 0; else iOK[2] = 1;
		}
		if (pQueue[3]) {
			SetDlgItemInt(IDC_EDIT7, queue[3].currentDepth(), FALSE);
			if (queue[3].currentDepth() > (dWarning * queue[3].maximumDepth())) iOK[3] = 0; else iOK[3] = 1;
		}
		if (pQueue[4]) {
			SetDlgItemInt(IDC_EDIT9, queue[4].currentDepth(), FALSE);
			if (queue[4].currentDepth() > (dWarning * queue[4].maximumDepth())) iOK[4] = 0; else iOK[4] = 1;
		}

    // set max for spin button
		int iCheck = 0;
		//Which radio button selected?
		if (IsDlgButtonChecked(IDC_RADIO1)) iCheck = 0;
		if (IsDlgButtonChecked(IDC_RADIO2)) iCheck = 1;
		if (IsDlgButtonChecked(IDC_RADIO3)) iCheck = 2;
		if (IsDlgButtonChecked(IDC_RADIO4)) iCheck = 3;
		if (IsDlgButtonChecked(IDC_RADIO5)) iCheck = 4;

		switch (iCheck) {
		case 0:
			((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetRange(1, GetDlgItemInt(IDC_EDIT1, NULL, TRUE));
			break;
		case 1:
			((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetRange(1, GetDlgItemInt(IDC_EDIT3, NULL, TRUE));
			break;
		case 2:
			((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetRange(1, GetDlgItemInt(IDC_EDIT5, NULL, TRUE));
			break;
		case 3:
			((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetRange(1, GetDlgItemInt(IDC_EDIT7, NULL, TRUE));
			break;
		default:
			((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN1))->SetRange(1, GetDlgItemInt(IDC_EDIT9, NULL, TRUE));
		}
		
	}
}

void CWatchMeDlg::emptyQ(int i) {
	int										iReturnCode;
	ImqQueue							queue;
	ImqGetMessageOptions	gmo;					// Get message options           
	ImqMessage						msg;					// Data message                  
  
	// Are you sure?
	if (((CButton *)GetDlgItem(IDC_CHECK3))->GetCheck() ) 
		if (MessageBox("Are you sure you want to delete all messages from the selected queue?", "Empty Queue?", MB_ICONQUESTION + MB_YESNO + MB_APPLMODAL) == IDNO)
	  	return;

	if (iInactive) {
			iInactive = 0;
			SetTimer(0, iTimer, NULL);
	} else {

		queue.setName( pQueue[i] );
		queue.setConnectionReference( this->qmgr );
		msg.setMessageLength(0);

		iReturnCode = queue.setOpenOptions( MQOO_INPUT_AS_Q_DEF | MQOO_FAIL_IF_QUIESCING );
		gmo.setOptions ( MQGMO_FAIL_IF_QUIESCING | MQGMO_ACCEPT_TRUNCATED_MSG);
		while (iReturnCode) {
			msg.setMessageId ();
			msg.setCorrelationId ();
			iReturnCode = queue.get( msg, gmo );
		}
	}
}

void CWatchMeDlg::OnButton1() 
{
  
	emptyQ(0);
	
}

void CWatchMeDlg::OnButton2() 
{
	emptyQ(1);
	
}

void CWatchMeDlg::OnButton3() 
{
	emptyQ(2);
	
}

void CWatchMeDlg::OnButton4() 
{
	emptyQ(3);
	
}

void CWatchMeDlg::OnButton5() 
{
	emptyQ(4);
	
}

void CWatchMeDlg::OnDisplayButton() 
{
	ImqGetMessageOptions  gmo;
	ImqMessage						msg;
	ImqBinary							mid, cid;
	unsigned char *pData;
	char *pData2;

	int i, iCheck = 0, iMessageNumber = 0, iReturnCode;
  //Which radio button selected?
	if (IsDlgButtonChecked(IDC_RADIO1)) iCheck = 0;
	if (IsDlgButtonChecked(IDC_RADIO2)) iCheck = 1;
	if (IsDlgButtonChecked(IDC_RADIO3)) iCheck = 2;
	if (IsDlgButtonChecked(IDC_RADIO4)) iCheck = 3;
	if (IsDlgButtonChecked(IDC_RADIO5)) iCheck = 4;

	//What record must I display
  iMessageNumber = GetDlgItemInt(IDC_EDIT12, NULL, FALSE);
	if (iMessageNumber < 1) {
		SetDlgItemText(IDC_EDIT13, " ");
		SetDlgItemText(IDC_EDIT14, " ");
		SetDlgItemText(IDC_EDIT15, " ");
		return;
	}

	//Display the record
	gmo.setOptions(MQGMO_BROWSE_FIRST | MQGMO_FAIL_IF_QUIESCING);
	queue[iCheck].setOpenOptions( MQOO_INPUT_AS_Q_DEF | MQOO_FAIL_IF_QUIESCING );
  queue[iCheck].get(msg, gmo);
	for (i=0;i<iMessageNumber;i++) {
		msg.setMessageId ();
    msg.setCorrelationId ();
	  iReturnCode = queue[iCheck].get( msg, gmo );
		if (!iReturnCode) {
			SetDlgItemText(IDC_EDIT13, " ");
			SetDlgItemText(IDC_EDIT14, " ");
			SetDlgItemText(IDC_EDIT15, " ");
			SetDlgItemText(IDC_EDIT21, " ");
			return;
		}
		gmo.setOptions(MQGMO_BROWSE_NEXT | MQGMO_FAIL_IF_QUIESCING);
	}
	i = msg.dataLength();
	if (i<50) i = 50;
	if (((CButton *)GetDlgItem(IDC_CHECK2))->GetCheck() ) {
		pData  = (unsigned char *)malloc(3*i+1);
		pData2 = (char*)msg.dataPointer();
		for (i=0;i<(signed)msg.dataLength();i++) {
			sprintf((char *)pData+3*i, "%.2X ", *(unsigned char *)(pData2+i));
		}
	} else {
		pData  = (unsigned char *)malloc(i+1);
		strncpy((char *)pData, msg.dataPointer(), i);
		*(pData+msg.dataLength()) = 0x0;
	}
	
	SetDlgItemText(IDC_EDIT13, (char *)pData);
	SetDlgItemInt(IDC_EDIT21, msg.dataLength());
	mid = msg.messageId();
	pData2 = (char *)mid.dataPointer();
	for (i=0;i<24;i++) {
		sprintf((char *)pData+2*i, "%.2X", *(unsigned char *)(pData2+i));
	}
	SetDlgItemText(IDC_EDIT14, (char *)pData);
	cid = msg.correlationId();
	pData2 = (char *)cid.dataPointer();
	for (i=0;i<24;i++) {
		sprintf((char *)pData+2*i, "%.2X", *(unsigned char *)(pData2+i));
	}
	SetDlgItemText(IDC_EDIT15, (char *)pData);
	free(pData);
}


void CWatchMeDlg::OnCheck1() 
{
	if (((CButton *)GetDlgItem(IDC_CHECK1))->GetCheck() ) {
	  // float window on top	
		SetWindowPos( &wndTopMost , 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW );
	} else {
    // do not float window on top
		SetWindowPos( &wndNoTopMost , 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW );
	}
}

void CWatchMeDlg::OnCheck2() 
{
	CWatchMeDlg::OnDisplayButton();
	
}


void CWatchMeDlg::OnDeleteButton() 
{
	ImqGetMessageOptions  gmo;
	ImqMessage						msg;
	ImqBinary							mid, cid;
	unsigned char *pData = (unsigned char *)malloc(201);
//	char *pData2;

	int i, iCheck = 0, iMessageNumber = 0, iReturnCode;
  //Which radio button selected?
	if (IsDlgButtonChecked(IDC_RADIO1)) iCheck = 0;
	if (IsDlgButtonChecked(IDC_RADIO2)) iCheck = 1;
	if (IsDlgButtonChecked(IDC_RADIO3)) iCheck = 2;
	if (IsDlgButtonChecked(IDC_RADIO4)) iCheck = 3;
	if (IsDlgButtonChecked(IDC_RADIO5)) iCheck = 4;

	//What record must I delete
	iMessageNumber = GetDlgItemInt(IDC_EDIT12, NULL, FALSE);
	if (iMessageNumber < 1) {
		SetDlgItemText(IDC_EDIT13, " ");
		SetDlgItemText(IDC_EDIT14, " ");
		SetDlgItemText(IDC_EDIT15, " ");
		return;
	}


	//Set message pointer to correct message
	gmo.setOptions(MQGMO_BROWSE_FIRST | MQGMO_FAIL_IF_QUIESCING);
	queue[iCheck].setOpenOptions( MQOO_INPUT_AS_Q_DEF | MQOO_FAIL_IF_QUIESCING );
  queue[iCheck].get(msg, gmo);
	for (i=0;i<iMessageNumber;i++) {
		msg.setMessageId ();
    msg.setCorrelationId ();
	  iReturnCode = queue[iCheck].get( msg, gmo );
		if (!iReturnCode) {
			SetDlgItemText(IDC_EDIT13, " ");
			SetDlgItemText(IDC_EDIT14, " ");
			SetDlgItemText(IDC_EDIT15, " ");
			return;
		}
		gmo.setOptions(MQGMO_BROWSE_NEXT | MQGMO_FAIL_IF_QUIESCING);
	}
	// now r							emove the message
	gmo.setOptions(MQGMO_MSG_UNDER_CURSOR | MQGMO_FAIL_IF_QUIESCING);
	msg.setMessageId ();
  msg.setCorrelationId ();
	iReturnCode = queue[iCheck].get( msg, gmo );
  // Display new message 5
	OnDisplayButton();
}

HBRUSH CWatchMeDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	
	switch (nCtlColor) {

		case CTLCOLOR_EDIT:
    case CTLCOLOR_MSGBOX:
		case CTLCOLOR_BTN:
			// If Everything OK, then set color to black on green and return the background brush.
			if (*pWnd == *GetDlgItem(IDC_EDIT1)) {
				switch (iOK[0]) {
				case 1:
					pDC->SetTextColor(RGB(0, 0, 255));
					pDC->SetBkColor(RGB(0, 255, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				case 0:
					pDC->SetTextColor(RGB(255, 255, 255));
					pDC->SetBkColor(RGB(255, 0, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				default:
					pDC->SetTextColor(RGB(0, 0, 0));
					pDC->SetBkColor(RGB(0, 0, 255));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}

			if (*pWnd == *GetDlgItem(IDC_EDIT3)) {
				switch (iOK[1]) {
				case 1:
					pDC->SetTextColor(RGB(0, 0, 255));
					pDC->SetBkColor(RGB(0, 255, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				case 0:
					pDC->SetTextColor(RGB(255, 255, 255));
					pDC->SetBkColor(RGB(255, 0, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				default:
					pDC->SetTextColor(RGB(0, 0, 0));
					pDC->SetBkColor(RGB(0, 0, 255));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}

			if (*pWnd == *GetDlgItem(IDC_EDIT5)) {
				switch (iOK[2]) {
				case 1:
					pDC->SetTextColor(RGB(0, 0, 255));
					pDC->SetBkColor(RGB(0, 255, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				case 0:
					pDC->SetTextColor(RGB(255, 255, 255));
					pDC->SetBkColor(RGB(255, 0, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				default:
					pDC->SetTextColor(RGB(0, 0, 0));
					pDC->SetBkColor(RGB(0, 0, 255));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}

			if (*pWnd == *GetDlgItem(IDC_EDIT7)) {
				switch (iOK[3]) {
				case 1:
					pDC->SetTextColor(RGB(0, 0, 255));
					pDC->SetBkColor(RGB(0, 255, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				case 0:
					pDC->SetTextColor(RGB(255, 255, 255));
					pDC->SetBkColor(RGB(255, 0, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				default:
					pDC->SetTextColor(RGB(0, 0, 0));
					pDC->SetBkColor(RGB(0, 0, 255));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}

			if (*pWnd == *GetDlgItem(IDC_EDIT9)) {
				switch (iOK[4]) {
				case 1:
					pDC->SetTextColor(RGB(0, 0, 255));
					pDC->SetBkColor(RGB(0, 255, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				case 0:
					pDC->SetTextColor(RGB(255, 255, 255));
					pDC->SetBkColor(RGB(255, 0, 0));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				default:
					pDC->SetTextColor(RGB(0, 0, 0));
					pDC->SetBkColor(RGB(0, 0, 255));
					return (HBRUSH)(m_pEditBkBrush->GetSafeHandle());
				}
			}
		default:
      return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
  }
}


void CWatchMeDlg::OnGenerate() 
{
	int iCheck;

	strcpy(pGData, "gs.exe ");   //100 0 0 b 1024");
	strcat(pGData, pQmgr);				// Queue manager name
	strcat(pGData, " ");
	//Which radio button selected?   To get correct queue to put
	if (IsDlgButtonChecked(IDC_RADIO1)) iCheck = 0;
	if (IsDlgButtonChecked(IDC_RADIO2)) iCheck = 1;
	if (IsDlgButtonChecked(IDC_RADIO3)) iCheck = 2;
	if (IsDlgButtonChecked(IDC_RADIO4)) iCheck = 3;
	if (IsDlgButtonChecked(IDC_RADIO5)) iCheck = 4;
	strcat(pGData, pQueue[iCheck]);	// queue name
	strcat(pGData, " ");
	iCheck = GetDlgItemInt(IDC_EDIT16, NULL, FALSE);
	_itoa(iCheck,pGData2, 10);
	strcat(pGData, pGData2);					// number of messages
	strcat(pGData, " ");
	iCheck = GetDlgItemInt(IDC_EDIT17, NULL, FALSE);
	_itoa(iCheck,pGData2, 10);
	if (((CButton *)GetDlgItem(IDC_CHECK5))->GetCheck()) {
		strcat(pGData, "r ");
    strcat(pGData,pGData2);           // random time is in sleep time
	} else {
		strcat(pGData, pGData2);					// sleep time
		strcat(pGData, " 0");
	}
  strcat(pGData, " ");
	//_itoa(iCheck2,pGData2, 10);
	//strcat(pGData, pGData2);					// random time
	if (IsDlgButtonChecked(IDC_RADIO20)) {
		strcat(pGData, " b ");
		iCheck = GetDlgItemInt(IDC_EDIT19, NULL, FALSE);
		_itoa(iCheck,pGData2, 10);
		strcat(pGData, pGData2);				// size of random data
	} else if (IsDlgButtonChecked(IDC_RADIO21)) {
		strcat(pGData, " q ");
		GetDlgItemText(IDC_EDIT20, pGData2, 500);
		strcat(pGData, pGData2);
	} else 	if (IsDlgButtonChecked(IDC_RADIO22)) {
		strcat(pGData, " f ");
		GetDlgItemText(IDC_EDIT22, pGData2, 500);
		strcat(pGData, pGData2);
	}
	if (((CButton *)GetDlgItem(IDC_CHECK4))->GetCheck()) strcat(pGData, " 1");
	else strcat(pGData, " 0");
	
	char *args[1];
	args[0] = pGData;
  AfxBeginThread(GSmain, pGData);

}

void CWatchMeDlg::OnChangeMessageNumber() 
{
	if (iNowShow) CWatchMeDlg::OnDisplayButton();
	
}


void CWatchMeDlg::OnChangeRefresh() 
{
	iTimer = GetDlgItemInt(IDC_EDIT18, NULL, TRUE);
	iTimer *= 1000;
	SetTimer(0, iTimer, NULL);
}

void CWatchMeDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	MessageBox("Francois van der Merwe, francoisvdm@za.ibm.com", "Die persoon wat die program geskryf het", MB_OK + MB_ICONINFORMATION);	
	
	CDialog::OnLButtonUp(nFlags, point);
}

//--------------------------------

// Globals
int iGSLoop = 1;
int iGS =0,jGS = 0,kGS = 0,lGS = 0;
int iRenameError = 1;
int iGenerateTimestamp = 0;
char * pszGSQmgr;
ImqQueueManager GSqmgr;            /* Local Queue manager                 */

HANDLE hStopEvent;


//********************************************************************//
void SleepNow(int Sleepfor) {
//********************************************************************//
   hStopEvent=::CreateEvent(NULL, TRUE, FALSE, NULL);

   DWORD dwCause  = WaitForSingleObject(hStopEvent, Sleepfor);
}


//********************************************************************//
//********************************************************************//   
//********************************************************************//
UINT GSmain ( LPVOID pParam ) {
//********************************************************************//
//********************************************************************//
//********************************************************************//

  ImqQueue queue, sourcequeue;      // Queue                         
  ImqMessage msg;                   // Data message                  
  ImqGetMessageOptions gmo;         // Get message options           
	char *pszFilename;
	char *pPointer;
  int iReturnCode = 0;
  int iBufferSize = 0;
  int iNumfiles = 0;
	int iBuffersize, iSleep;
	int iMax = 1;
	int iNumread = 0;
	FILE * fInput;
	char args[9][50];

  sscanf((const char *)pParam, "%s %s %s %s %s %s %s %s %s", args[0], args[1], args[2], args[3], args[4], args[5], args[6], args[7], args[8]);

	struct _timeb timebuffer;
  MQBYTE24 cid;					// Correlation ID
	
	int iRepeat = atoi(args[3]);
	pP->SetRange(0, iRepeat);
	pP->SetStep(1);
  char cSleep = *args[4];
  char * pszBuffer, * pszStep;
  char cBuffer[20];
	char cOption = *args[6];

	if (cSleep != 'r')
		iSleep = atoi(args[4]);
	else 
		iMax = atoi(args[5]);
  
  pszGSQmgr = args[1];
	iGenerateTimestamp = atoi(args[8]);

	// connect to queue manager
  GSqmgr.setName(args[ 1 ]);
  if ( ! GSqmgr.connect( ) ) {
		/* stop if it failed */
		printf( "ImqQueueManager::connect ended with reason code %d\n",(int)GSqmgr.reasonCode( ) );
		return (int)GSqmgr.reasonCode( );
  }

	switch (cOption) {
		case 'b': 
			iBuffersize = atoi(args[7]);
			// create buffer for dummy data
			pszBuffer = (char *)malloc( iBuffersize );
			// Fill buffer with random data
			srand( (unsigned)time( NULL ) );
			pszStep = pszBuffer;
			for (iGS=0;iGS<iBuffersize;iGS++) {
				*pszStep = *itoa(rand(), cBuffer, 10);
				pszStep++;
			}
			// use buffer in the case of random generated message
			iReturnCode = msg.useFullBuffer(pszBuffer, iBuffersize);
			msg.setFormat( MQFMT_STRING );
		  break;
		case 'q':
			sourcequeue.setName ( args[7] );
			sourcequeue.setConnectionReference (GSqmgr);
			sourcequeue.setOpenOptions (MQOO_INPUT_AS_Q_DEF | MQOO_FAIL_IF_QUIESCING);
			gmo.setOptions ( MQGMO_FAIL_IF_QUIESCING | MQGMO_BROWSE_FIRST );
			if (sourcequeue.currentDepth() == 0) {
				printf("No messages in the input queue %s\n", args[7]);
				exit(0);
			}
			break;
		case 'f':
			pszFilename = args[7];
			fInput = fopen( pszFilename, "r" );
			if (!fInput) {
				printf("Problem opening file %s", pszFilename);
				exit(0);
			}
			// Get biggest record from file
			iBuffersize = 10;
			pszBuffer = (char *)malloc( iBuffersize );

			while (!feof(fInput)) {
				fgets( pszBuffer, iBuffersize, fInput);
				iNumread = strlen(pszBuffer);
				if ((iNumread+1) == iBuffersize) {
					free(pszBuffer);
					iBuffersize *= 2;
					pszBuffer = (char *)malloc( iBuffersize );
					fseek( fInput, 0L, SEEK_SET);
				}
			}
			fseek( fInput, 0L, SEEK_SET);
			
			msg.setFormat( MQFMT_STRING );
			break;
		default :
			printf("Invalid source value: %c\n", cOption);
			exit(0);
	}

  // open target queue
  iReturnCode = queue.setName( args[2] );
  queue.setConnectionReference( GSqmgr );
  iReturnCode = queue.setOpenOptions( MQOO_OUTPUT );
  
  queue.setCloseOptions( MQCO_NONE );

  for (iGS=0;iGS<MQ_CORREL_ID_LENGTH;iGS++)
		cid[iGS] = 0x0;
  
  for (iGS=1;iGS<=iRepeat;iGS++) {
		switch (cOption) {
			case 'b' :
				break;
			case 'f' :
				// Read records in source file one by one, wrap to beginning
				if (!fgets( pszBuffer, iBuffersize, fInput)) {
					fseek( fInput, 0L, SEEK_SET);
					fgets( pszBuffer, iBuffersize, fInput);
				}
				if(pPointer = strchr(pszBuffer, 0x0A)) {
					*pPointer = 0x0;
				}

				iNumread = strlen(pszBuffer);
				iReturnCode = msg.useFullBuffer(pszBuffer, iNumread);
				break;
			case 'q' :
				// Read msgs in source queue one by one, wrap to beginning
				msg.setMessageId ();
				msg.setCorrelationId ();
				if ( !sourcequeue.get(msg, gmo) ) {
					gmo.setOptions ( MQGMO_FAIL_IF_QUIESCING | MQGMO_BROWSE_FIRST );
					if ( !sourcequeue.get(msg, gmo) ) {
						printf("Funny error - oops");
						exit(0);
					}
				}
				gmo.setOptions ( MQGMO_FAIL_IF_QUIESCING | MQGMO_BROWSE_NEXT );
				break;
		}
		if (iGenerateTimestamp) {
			// set the start time in the correlation ID - yeah, I know it is not perfect
			_ftime( &timebuffer );
			memcpy(cid, &timebuffer, 6);
			msg.setCorrelationId(cid);
		} else msg.setCorrelationId();
		msg.setMessageId ();
		iReturnCode = queue.put( msg );
		// any errors
		if (queue.reasonCode()) {
			printf( "ImqQueue::put ended with reason code %d\n",(int)queue.reasonCode( ) );
			iReturnCode = queue.close();
			iReturnCode = GSqmgr.disconnect( );
			return iReturnCode ;
		}
		pP->StepIt();
		// on request, sleep for random amount of seconds
		if (cSleep == 'r') if (iMax) iSleep = div(rand(),iMax).rem;
		if (iSleep > 0) {
			SleepNow(iSleep);
		}
  }  // for
  iReturnCode = queue.close();

  switch (cOption) {
		case 'b':
			free(pszBuffer);
			break;
		case 'q' :
			iReturnCode = sourcequeue.close();
			break;
		case 'f' :
			free(pszBuffer);
			fclose(fInput);
			break;
	}
  iReturnCode = GSqmgr.disconnect( );
	pP->SetPos(0);
  return iReturnCode ;
}
